﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Threading;
using System.Linq.Expressions;
using System.Diagnostics;
using System.Reflection;
using Infragistics.Windows.Reporting;
using System.Collections;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        class A : ObservableObject
        {
            private long name;

            static readonly Random rand = new Random();

            public A()
            {
                Name = 1;
                IsSelected = rand.Next(0, 2) == 1;
            }

            public bool IsSelected { get; set; }

            public long Name
            {
                get { return name; }
                set
                {
                    name = value;
                    RaisePropertyChanged(() => this.Name);
                }
            }

            public void Random()
            {
                Name++;
            }

            public override void Dispose()
            {
                
            }

            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;

            #endregion
        }

        private BindingList<A> _list1 = new BindingList<A>();

        private BindableList<A> _list2 = new BindableList<A>() { AllowEdit = true, AllowNew = true, AllowRemove = true };

        public MainWindow()
        {
            InitializeComponent();
            var array = Enumerable.Repeat(0, 10).Select(i => new A()).ToArray();
            xamDataGrid1.DataSource = _list1;
            xamDataGrid2.DataSource = _list2;
        }

        private void Process(IList list)
        {
            foreach (A a in (list as IEnumerable<A>))
                a.Random();
            if (list.Count < 5)
                list.Add(new A());
        }

        void worker_DoWork(object sender, DoWorkEventArgs e)
        {
            while (true)
            {
                Thread.Sleep(1000);
                Dispatcher.Invoke(new Action(() =>
                    {
                        Process(_list1);
                        Process(_list2);
                    }));
            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            BackgroundWorker worker = new BackgroundWorker();
            worker.DoWork += new DoWorkEventHandler(worker_DoWork);
            worker.RunWorkerAsync();
        }
    }
}
